/*
 *  Copyright 2010 Anyware Services
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */

Ext.namespace('org.ametys.ribbon.control.button');

org.ametys.ribbon.control.button.ZoneActionButton = function(id, configuration, pluginName) 
{
	org.ametys.ribbon.control.button.ZoneActionButton.superclass.constructor.call(this, id, configuration, pluginName);
};

Ext.extend(org.ametys.ribbon.control.button.ZoneActionButton, org.ametys.ribbon.control.button.ActionButton, {});

org.ametys.ribbon.control.button.ZoneActionButton.prototype.createControl = function(colspan)
{
	var elmt = org.ametys.ribbon.control.button.ZoneActionButton.superclass.createControl.call(this, colspan);
	elmt.disable();
	return elmt;
}

org.ametys.ribbon.control.button.ZoneActionButton.prototype.onMessage = function(messages)
{
	for (var i=0; i < messages.length; i++)
	{
		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED
				|| messages[i].getType().getName() == "templateChanged"
				|| messages[i].getType().getName() == "typeChanged")
		{
			var targets = messages[i].getTargets();
			
			this._pagesTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, function(target) {return target.getType() == "page"} );
			
			var atLeastAContainerPage = false;
			this._targetPagesId = [];

			for (var j = 0; j < this._pagesTargets.length; j++)
			{
				var pageTarget = this._pagesTargets[j];
				if (pageTarget.getParameters()["type"] == "container" && pageTarget.getParameters()["zone-name"] != null)
				{
					atLeastAContainerPage = true;
				}
			}

			this.getElements().each(function(element) { element.setDisabled(!atLeastAContainerPage); })
		}
	}
}